HDU_2955_Robberies_01背包

A - Robberies
Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u
Submit  Status  Practice  HDU 2955

Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university. 


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible. 


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set. 

Notes and Constraints 
0 < T <= 100 
0.0 <= P <= 1.0 
0 < N <= 100 
0 < Mj <= 100 
0.0 <= Pj <= 1.0 
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input

3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

Sample Output

2 4 6
 
2016.4.22,在做这道题时,发现依然问题多多。
1.概率是个小数,这次第一个思路是乘100然后用其作为消耗,这显然不对,首先double转int就会有误差,其次概率之间的关系不是简单的求和(显然读题不仔细)。题目中说的是,在小于被抓住的概率下拿到最多的钱,dp[0]被抓的概率为0不被抓的概率为1,由此应讨论不被抓的概率。dp[j]中存的是拿到j的价值而不被抓的概率。最后只需从后往前判断概率大小即可。
 
 
 
 题解:用不被抓到的概率来处理,状态转移方程相对简单。把可能抢到的钱数所对应的不被抓住的概率存入dp数组,再for(i=sum;i>=0;i++)如果能抢到的最大钱数所对应的不被抓概率大于(1-p)则输出i,然后跳出循环,该i值为最大钱数

 

 代码:
#include<stdio.h>
double max(double a,double b)
{
    return a>b?a:b;
}
int main()
{
    int t,n,M[110],i,j,sum;
    double p,P[110],dp[10010];   //dp为背包最大容量
    scanf("%d",&t);
    while(t--)
    {
        sum=0;
        scanf("%lf%d",&p,&n);
        dp[0]=1;              //当抢到的钱为零时,不被抓的概率为1
        for(i=0; i<n; i++)
        {
            scanf("%d%lf",&M[i],&P[i]);
            sum+=M[i];
        }
        for(i=1; i<=sum; i++)     //需将除dp[0]以外的所有元素初始化为零,因为状态转移方程要比较大小再赋值,见图。之前错在此处。
            dp[i]=0.0;
        for(i=0; i<n; i++)              //此循环为遍历银行
            for(j=sum; j>=M[i]; j--)     //此处不易理解。假设银行(1,0.02)(2,0.03)(3,0.05)  此循环大概功能:dp[6]=dp[3]*P[3],dp[3]=dp[1]*P[2].
                dp[j]=max(dp[j],dp[j-M[i]]*(1-P[i]));    //状态转移方程
        for(i=sum; i>=0; i--)
            if(dp[i]>=(1.0-p))
            {
                printf("%d\n",i);
                break;
            }
    }
    return 0;
}

  

转载于:https://www.cnblogs.com/jasonlixuetao/p/4423247.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值